unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    StringGrid1: TStringGrid;
    Button2: TButton;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Edit4: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure StringGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  arDouble: array of Double;

implementation

{$R *.dfm}

procedure RefreshArray;
var
  i: Integer;
begin
  Form1.StringGrid1.RowCount := Length(arDouble);
  for i := 0 to Length(arDouble) - 1 do
    Form1.StringGrid1.Cells[0, i] := FloatToStr(arDouble[i]);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SetLength(arDouble, 10);
  RefreshArray;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SetLength(arDouble, StrToInt(Edit1.Text));
  RefreshArray;
end;

procedure TForm1.StringGrid1SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var
  dValue: Double;
begin
  try
    if Value <> '' then
      begin
        dValue := StrToFloat(Value);
        arDouble[ARow] := dValue;
      end
    else
      arDouble[ARow] := 0;
  except
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  sum, max, min: Double;
  i: Integer;
begin
  min := arDouble[0];
  max := arDouble[0];
  sum := arDouble[0];
  for i := 1 to Length(arDouble) - 1 do
    begin
      if min > arDouble[i] then
        min := arDouble[i];
      if max < arDouble[i] then
        max := arDouble[i];
      sum := sum + arDouble[i];
    end;

  Form1.Edit2.Text := FloatToStr(max);
  Form1.Edit3.Text := FloatToStr(min);
  Form1.Edit4.Text := FloatToStr(sum / Length(arDouble));
end;

end.
